load workspace_bk2

nvotes = sum(train_data>0,2);
perm=randperm(5000);
[foo,ind]=sort(-nvotes);
u=perm(1:1000);

%Compute exact distribution
KL=0;
Entz=0;
logPzx=zeros(2^10,100);
logPazgx=zeros(2^10,100);
Pezgx=zeros(2^10,100);
for i=1:1000
  [foo,Y,V]=find(train_data(u(i),:));
  umu=mu(:,u(i));
  for d=0:(2^10-1)   
    f=(dec2bin(d,10)-48);
    f_ind=find(f); 
    fvy= squeeze(sum(log(Pvky(:,f_ind,:)),2));

    B=floor(709-log(10)-max(fvy(:,Y),[],1));
    B=repmat(B,[num_votes,1]);
    fy=log(sum(exp(fvy(:,Y)+B)))-B(1,:);
 
    %temp2=squeeze(log(max(sum(prod(Pvky(:,f_ind,Y),2),1),eps)));
    ind=sub2ind([num_votes,num_items],V,Y);
    logPzx(d+1,i)=sum(fvy(ind))-sum(fy)+sum(f'.*log(eta)+(1-f').*log(1-eta));
    logPzx(d+1,i);
    logPazgx(d+1,i) = sum(log(umu).*(f') + log(1-umu).*(1-f'));
  end


  B=floor(709-log(2^10)-max(logPzx(:,i)));
  logPezgx(:,i)=logPzx(:,i) - log(sum(exp(logPzx(:,i)+B)))+B;

  Pezgx(:,i)=exp(logPezgx(:,i));
  %Pezgx2(:,i)=exp(logPzx(:,i))./sum(exp(logPzx(:,i)));

  Entz(i) = -sum(Pezgx(:,i).*log(max(Pezgx(:,i),eps)));
  KL(i) = sum(Pezgx(:,i).*(log(max(Pezgx(:,i),eps))-logPazgx(:,i)));

  fprintf('%d %f %f %f\n',nvotes(u(i)),Entz(i),KL(i),KL(i)/Entz(i));
end

save worspace_bk3
